---
name: Bug report
about: Create a report to help us improve

---

### Problem description
A clear and concise description of what the problem is.

### Reproduction steps
Give very precise steps you've discovered to reproduce your problem. If possible and applicable, provide us with a repository we can clone that contains a reproduction case. Also if possible and applicable, please include a Dockerfile that exhibits the problem if it's specific to a certain environment. Bug reports with no reproduction steps will be closed.

### Environment
 - OS name, version and architecture: [e.g. Linux Ubuntu 18.04 amd64]
 - Node version [e.g. 8.10.0]
 - Node installation method [e.g. nvm]
 - If applicable, compiler version [e.g. clang 3.8.0-2ubuntu4]
 - Package name and version [e.g. gRPC@1.12.0]

### Additional context
Add any other context about the problem here. If possible, attach full logs. Do not try to omit anything for brevity, but instead include absolutely everything. Please try and set your operating system's locale to English, so that logs contain error messages in the English language.
